Add e2fsck init script - scans every ext2/ext3 mount from fstab
authorFlorian Fainelli <florian@openwrt.org>
Sat, 31 Jan 2009 12:55:55 +0000 (12:55 +0000)
committerFlorian Fainelli <florian@openwrt.org>
Sat, 31 Jan 2009 12:55:55 +0000 (12:55 +0000)
Signed-off-by: Vasilis Tsiligiannis <b_tsiligiannis@silverton.gr>
SVN-Revision: 14301

package/e2fsprogs/Makefile
package/e2fsprogs/files/e2fsck.init [new file with mode: 0644]

index e01828e..b8bf345 100644 (file)
@@ -10,7 +10,7 @@ include $(TOPDIR)/rules.mk
 
 PKG_NAME:=e2fsprogs
 PKG_VERSION:=1.40.11
-PKG_RELEASE:=2
+PKG_RELEASE:=3
 
 PKG_SOURCE:=$(PKG_NAME)-$(PKG_VERSION).tar.gz
 PKG_SOURCE_URL:=@SF/e2fsprogs
@@ -146,6 +146,9 @@ define Package/e2fsprogs/install
        ln -sf mke2fs $(1)/usr/sbin/mkfs.ext3
        $(INSTALL_DIR) $(1)/usr/lib
        $(CP) $(foreach lib,com_err e2p,$(PKG_INSTALL_DIR)/usr/lib/lib$(lib).so.*) $(1)/usr/lib/
+       $(INSTALL_DIR) $(1)/etc/init.d
+       $(INSTALL_BIN) ./files/e2fsck.init $(1)/etc/init.d/e2fsck
+
 endef
 
 define Package/libuuid/install
diff --git a/package/e2fsprogs/files/e2fsck.init b/package/e2fsprogs/files/e2fsck.init
new file mode 100644 (file)
index 0000000..e66750c
--- /dev/null
@@ -0,0 +1,35 @@
+#!/bin/sh /etc/rc.common
+# Copyright (C) 2008 OpenWrt.org
+# Vasilis Tsiligiannis <acinonyxs@yahoo.gr>
+
+START=15
+
+e2fsck() {
+       local args
+       local cfg="$1"
+
+       config_get device "$cfg" device
+       [ -b "$device" ] || return 0
+
+       config_get fstype "$cfg" fstype
+       case "$fstype" in
+               ext2|ext3)
+                       /usr/sbin/e2fsck -p "$device"
+                       local status="$?"
+                       case "$status" in
+                               0|1) continue;;
+                               2) reboot;;
+                               4) echo "e2fsck ($device): Warning! Uncorrected errors.";;
+                               *) echo "e2fsck ($device): Error $status. Check not complete.";;
+                       esac
+                       ;;
+               *)
+                       ;;
+       esac
+}
+
+start() {
+       config_load fstab
+       config_foreach e2fsck mount
+}
+